#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "variables.h"

#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <unistd.h>

//#define DEBUG_1

GString *fichero,*fichero_temporal,*fichero_book,*fichero_book2,*fichero_grupos,*fichero_salida,*fichero_pares;

guint copias;

/* counts the number of pages in the file */

int num_pages(gchar *fichero) {
	
	int counter=0,value_page,leidos;
	gchar cadena[6];
	FILE *file_id;
	
	printf("fichero a ver %s\n",fichero);
	file_id=fopen(fichero,"r");
	if(file_id==NULL)
		return -1;
	leidos=fscanf(file_id,"%c",cadena); // read a character
	while(!feof(file_id)) {
		if(cadena[0]=='%') { // is a % character?
			leidos=fscanf(file_id,"%c",cadena); // read next character
			if(cadena[0]=='%') { // is another % character?
				leidos=fscanf(file_id,"%5c",cadena);
				cadena[5]=0;
				if((leidos!=0)&&(0==strcmp(cadena,"Page:"))) { // found a Page command?
					leidos=fscanf(file_id,"%d",&value_page); // read the number					
					if(counter<value_page)
						counter=value_page;
				}
			}
		}
		while((cadena[0]!='\n')&&(!feof(file_id)))
			leidos=fscanf(file_id,"%c",cadena); // jump to the next carriage return
		do
			leidos=fscanf(file_id,"%c",cadena); // read a character
		while((!feof(file_id))&&(cadena[0]<31)); // jump over other control characters, if any
	}
	return (counter);
}

void run_command(gchar *comando) {

  system(comando);

}

void print_file(gchar *fichero) {

  GString *cadena;
  GtkWidget *wcomando;
  const gchar *comando;

  wcomando=lookup_widget(mainwindow,"impresora");
  comando=gtk_entry_get_text(GTK_ENTRY(wcomando));
  cadena=g_string_new("");
  g_string_sprintf(cadena,"%s %s %s",comando,parametros->str,fichero);  
  run_command(cadena->str);
  g_string_free(cadena,TRUE);

}

void remove_file(gchar *fichero) {

  GString *cadena;

  cadena=g_string_new("");
  g_string_sprintf(cadena,"rm %s",fichero);
  run_command(cadena->str);
  g_string_free(cadena,TRUE);
}

void set_configuration(gboolean t1,gboolean t2,gboolean t3, gboolean bmanual,
		       gboolean binvert, gboolean binvertodd, gboolean binverteven,
		       gboolean bactivate_buttons) {

  GtkWidget *type1,*type2,*type3,*manual,*invert,*invertodd,*inverteven,*ok,*cancel;

  type1=lookup_widget(config_window,"canontype");
  type2=lookup_widget(config_window,"hptype");
  type3=lookup_widget(config_window,"lasertype");
  manual=lookup_widget(config_window,"manual");
  invert=lookup_widget(config_window,"invert");
  invertodd=lookup_widget(config_window,"invertodd");
  inverteven=lookup_widget(config_window,"inverteven");
  ok=lookup_widget(config_window,"confok");
  cancel=lookup_widget(config_window,"confcancel");

  if(bactivate_buttons)
    gtk_widget_set_sensitive(ok,1);
  else
    gtk_widget_set_sensitive(ok,0);

  if((bactivate_buttons)&&(!first_time))
    gtk_widget_set_sensitive(cancel,1);
  else
    gtk_widget_set_sensitive(cancel,0);

  gtk_widget_set_sensitive(invert,1);
  gtk_widget_set_sensitive(invertodd,1);
  gtk_widget_set_sensitive(inverteven,1);

  if(binvert)
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(invert),1);
  else
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(invert),0);

  if(binvertodd)
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(invertodd),1);
  else
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(invertodd),0);

  if(binverteven)
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(inverteven),1);
  else
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(inverteven),0);

  if(bmanual) {
    gtk_widget_set_sensitive(invert,1);
    gtk_widget_set_sensitive(invertodd,1);
    gtk_widget_set_sensitive(inverteven,1);
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(manual),1);
  } else {
    gtk_widget_set_sensitive(invert,0);
    gtk_widget_set_sensitive(invertodd,0);
    gtk_widget_set_sensitive(inverteven,0);
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(manual),0);
  }

  if(t1)
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(type1),1);
  else
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(type1),0);

  if(t2)
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(type2),1);
  else
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(type2),0);

  if(t3)
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(type3),1);
  else
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(type3),0);

}

void finaliza() {

  remove_file(fichero_pares->str);
  remove_file(fichero_salida->str);
  g_string_free(fichero_salida,TRUE);
  g_string_free(fichero_pares,TRUE);
  gtk_main_quit();

}

void save_config() {

  FILE *fichero;
  GString *cadena;
  GtkWidget *printer;
  const gchar *comando;

  printer=lookup_widget(mainwindow,"impresora");

  cadena=g_string_new(getenv("HOME"));
  g_string_append(cadena,"/.gtkpsproc");
  fichero=fopen(cadena->str,"w");
  
  if(fichero==NULL) {
	  printf("Error al grabar %s\n",cadena->str);
    return;
  }

  comando=gtk_entry_get_text(GTK_ENTRY(printer));
  if(comando[0]==0)
  	fprintf(fichero,"%c%c%s",configuracion,margen,"lpr");
  else
	fprintf(fichero,"%c%c%s",configuracion,margen,comando);

  fclose(fichero);

}

void
on_libro_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

  GtkWidget *parimpar,*agrupa,*combo_agrupa;
  gint estado;

  if(GTK_TOGGLE_BUTTON (togglebutton)->active)
    estado=FALSE; // inactivate the other widgets
  else
    estado=TRUE; // activate the other widgets

  parimpar=lookup_widget(mainwindow,"parimpar");
  agrupa=lookup_widget(mainwindow,"agrupa");
  combo_agrupa=lookup_widget(mainwindow,"combo_agrupa");
  
  if(!estado) {
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(parimpar),TRUE);
    gtk_entry_set_text(GTK_ENTRY(agrupa),"2");
  }

  gtk_widget_set_sensitive(parimpar,estado);
  gtk_widget_set_sensitive(combo_agrupa,estado);
    
}


// prints all

void
on_aceptar_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{

  gchar separar=0,libro=0;
  const gchar *hojas,hojas2[2]="2",*hojas3;
  GtkWidget *entrada;
  GString *comando,*copiador;
  guint bucle,cantidad_hojas;

  save_config();

  // create a non_repeated file name

  fichero=g_string_new("");
  g_string_sprintf(fichero,"/var/tmp/gtkpsproc%d%d",(int)time(NULL),getpid());
  fichero_book=g_string_new("");
  g_string_sprintf(fichero_book,"%s_book.ps",fichero->str);
  fichero_book2=g_string_new("");
  g_string_sprintf(fichero_book2,"%s_book2.ps",fichero->str);
  fichero_grupos=g_string_new("");
  g_string_sprintf(fichero_grupos,"%s_grupos.ps",fichero->str);
  fichero_salida=g_string_new("");
  g_string_sprintf(fichero_salida,"%s_salida.ps",fichero->str);
  fichero_pares=g_string_new("");
  g_string_sprintf(fichero_pares,"%s_pares.ps",fichero->str);
  fichero_temporal=g_string_new("");
  g_string_sprintf(fichero_temporal,"%s_temporal.ps",fichero->str);


  copiador=g_string_new("");
  if(0==strcmp("/dev/stdin",ficherops->str))
	g_string_sprintf(copiador,"cat /dev/stdin > %s",fichero_temporal->str);	  
  else
	g_string_sprintf(copiador,"cp %s %s",ficherops->str,fichero_temporal->str);
  run_command(copiador->str);

  g_string_sprintf(ficherops,"%s",fichero_temporal->str);

  comando=g_string_new("");

  printf("Fichero temporal: %s\n",fichero_temporal->str);

  // look for the number of copies we want

  copias=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(lookup_widget(mainwindow,"copias")));

  cantidad_hojas=num_pages(ficherops->str); // here we count the number of pages to know how to reorder them

  // asign values to boolean variables

  if(GTK_TOGGLE_BUTTON (lookup_widget(mainwindow,"parimpar"))->active)
    separar=1;

  if(GTK_TOGGLE_BUTTON (lookup_widget(mainwindow,"libro"))->active) {

    // want book format
    libro=1;
    g_string_sprintf(comando,"pstops 4:-3,0,1,-2 %s %s",ficherops->str,fichero_book->str); // reorder pages	
    run_command(comando->str); // execute the command
	if(cantidad_hojas>4) { // if we have more than 4 pages, the book will have, at least, 8, so we have to re-reorder them again
	  g_string_sprintf(comando,"psnup -m0 -1 %s %s",fichero_book->str,fichero_book2->str); // renumber pages
      run_command(comando->str); // execute the command
      g_string_sprintf(comando,"pstops 8:0,1,2,3,-6,-7,-4,-5 %s %s",fichero_book2->str,fichero_book->str); // reorder pages again
      run_command(comando->str); // execute the command
      remove_file(fichero_book2->str);
    }
    g_string_sprintf(ficherops,"%s",fichero_book->str); // new file is BOOK
  }

  entrada=lookup_widget(mainwindow,"agrupa");
  hojas3=gtk_entry_get_text(GTK_ENTRY(entrada));

  if(libro)
    hojas=hojas2;
  else
	hojas=hojas3;

  if(hojas[0]=='1') // no group
    g_string_sprintf(comando,"cp %s %s",ficherops->str,fichero_grupos->str); // we must not delete the original file
  else
    g_string_sprintf(comando,"psnup -%s -m%d %s %s",hojas,((int)margen),ficherops->str,fichero_grupos->str);

  run_command(comando->str);

  if(libro)
    remove_file(fichero_book->str); // remove the book file if it was used

  if(separar) { // double-side printing
    if(configuracion&0x02)
      g_string_sprintf(comando,"pstops 2:-0 %s %s",fichero_grupos->str,fichero_salida->str); // invert odd pages
    else
      g_string_sprintf(comando,"pstops 2:0 %s %s",fichero_grupos->str,fichero_salida->str); // don't invert odd pages
    run_command(comando->str);
    if(configuracion&0x04)
      g_string_sprintf(comando,"pstops 2:-1 %s %s",fichero_grupos->str,fichero_pares->str); // invert even pages
    else
      g_string_sprintf(comando,"pstops 2:1 %s %s",fichero_grupos->str,fichero_pares->str); // don't invert even pages
    run_command(comando->str);
  } else {
    if(configuracion&0x01)
      g_string_sprintf(comando,"pstops 1:-0 %s %s",fichero_grupos->str,fichero_salida->str); // invert all pages
    else
      g_string_sprintf(comando,"cp %s %s",fichero_grupos->str,fichero_salida->str); // don't invert odd pages
    run_command(comando->str);
  }
  remove_file(fichero_grupos->str); // remove file grupos, with grouped pages
  
  for(bucle=0;bucle<copias;bucle++)
    print_file(fichero_salida->str);
  g_string_free(fichero,TRUE);
  g_string_free(fichero_book,TRUE);
  
  remove_file(fichero_temporal->str);
  
  if(separar) { // if we have to print the even pages...

    evenpagesOK = create_evenpagesOK ();
    gtk_widget_show (evenpagesOK);

  } else {
    remove_file(fichero_salida->str);
    g_string_free(fichero_salida,TRUE);
    g_string_free(fichero_pares,TRUE);
    gtk_main_quit();
  }
}


void
on_about_clicked                       (GtkButton       *button,
                                        gpointer         user_data)
{

  if(about_window==NULL)
    about_window=create_about_window();
  else
    gtk_widget_hide (about_window);
  gtk_widget_show(about_window);

}


void
on_evenok_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{

  guint bucle;

  for(bucle=0;bucle<copias;bucle++)
    print_file(fichero_pares->str);
  finaliza();

}


void
on_evencancel_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{

  finaliza();

}


void
on_about_ok_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{

  gtk_widget_destroy(about_window);
  about_window=NULL;

}


void
on_cancelar_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{

  save_config();
  gtk_main_quit();

}


gboolean
on_close_clicked                       (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  save_config();
  gtk_main_quit();
  return FALSE;
}


gboolean
on_oddpagesOK_delete_event             (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  finaliza();
  return FALSE;
}


void
on_configurar_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{

  gboolean t1,t2,t3,t4,invert,invertodd,inverteven;
  GtkWidget *margenes;

  config_window=create_configuracion();
  gtk_widget_show(config_window);

  margenes=lookup_widget(config_window,"margen");

  t1=FALSE;
  t2=FALSE;
  t3=FALSE;
  t4=FALSE;

  if(configuracion&0x01)
    invert=TRUE;
  else
    invert=FALSE;

  if(configuracion&0x02)
    invertodd=TRUE;
  else
    invertodd=FALSE;

  if(configuracion&0x04)
    inverteven=TRUE;
  else
    inverteven=FALSE;

  switch(configuracion&0x07) {
  case 1:
    t1=TRUE;
    break;
  case 3:
    t2=TRUE;
    break;
  case 4:
    t3=TRUE;
    break;
  default:
    t4=TRUE;
    break;
  }

  set_configuration(t1,t2,t3,t4,invert,invertodd,inverteven,TRUE);
  gtk_spin_button_set_value(GTK_SPIN_BUTTON(margenes),(gfloat)margen);

}


void
on_confok_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{

  GtkWidget *invert,*invertodd,*inverteven,*margenes;

  invert=lookup_widget(config_window,"invert");
  invertodd=lookup_widget(config_window,"invertodd");
  inverteven=lookup_widget(config_window,"inverteven");
  margenes=lookup_widget(config_window,"margen");

  margen=(gchar) gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(margenes));

  configuracion=0;

  if (GTK_TOGGLE_BUTTON (invert)->active)
    configuracion+=1;
  if (GTK_TOGGLE_BUTTON (invertodd)->active)
    configuracion+=2;
  if (GTK_TOGGLE_BUTTON (inverteven)->active)
    configuracion+=4;

  first_time=0;

  save_config();
  
  gtk_widget_destroy(config_window);

}


void
on_confcancel_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{

  gtk_widget_destroy(config_window);

}


void
on_canontype_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
  set_configuration(TRUE,FALSE,FALSE,FALSE,TRUE,FALSE,FALSE,TRUE);
}


void
on_hptype_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
  set_configuration(FALSE,TRUE,FALSE,FALSE,TRUE,TRUE,FALSE,TRUE);
}


void
on_lasertype_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
  set_configuration(FALSE,FALSE,TRUE,FALSE,FALSE,FALSE,TRUE,TRUE);
}


void
on_manual_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
  set_configuration(FALSE,FALSE,FALSE,TRUE,FALSE,FALSE,FALSE,TRUE);
}


void
on_firstOK_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{

  gtk_widget_destroy(first_time_window);
  first_time_window=NULL;
  config_window=create_configuracion();
  gtk_widget_show(config_window);
  set_configuration(FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE);
}

gboolean
on_mainwindow_destroy_event            (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  gtk_main_quit();
  return FALSE;
}
