/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "interface.h"
#include "support.h"
#include "variables.h"

#include <stdlib.h>
#include <stdio.h>
#include <sys/stat.h>
#include <unistd.h>

GtkWidget *mainwindow;
GtkWidget *evenpagesOK;
GtkWidget *about_window;
GtkWidget *first_time_window;
GtkWidget *config_window;
gint num_copias;

GString *ficherops; // filename for PS file
guchar configuracion,margen,first_time;
GString *parametros;

gint read_param(gint n_parametro,char *argv[]) {
	
	gchar *parametro;
	
	parametro=argv[n_parametro];
	n_parametro++;
	
	if(parametro[0]!='-') {
		if(ficherops==NULL) // only the first filename
			ficherops=g_string_new(parametro); // if it's not an option, it's the filename
		return n_parametro;
	}
	
	switch(parametro[1]) {
		case 'E':
		case 'p':
		case 'l':
			g_string_append_printf(parametros,"%s ",parametro); // theses options hasn't parameters
		break;
		case 'P':
		case 'C':
		case 'J':
		case 'T':
		case 'o':
			if(parametro[2]==0) { // the parameter isn't glued to the option
				g_string_append_printf(parametros,"%s %s ",parametro,argv[n_parametro]);
				n_parametro++;
			} else
				g_string_append(parametros,parametro); // the parameter is glued to the option		
		break;
		case 'r':
		case 'c':
		case 'd':
		case 'f':
		case 'g':
		case 'm':
		case 'n':
		case 't':
		case 'v':
			printf("WARNING: option %s not supported\n",parametro);
		break;
		case 'i':
		case 'w':
			printf("WARNING: option %s not supported\n",parametro);
			if(parametro[2]!=0) // the parameter isn't glued to the option
				n_parametro++;
		break;
		case '#':
			if(parametro[2]!=0) { // the parameter isn't glued to the option
				num_copias=atoi(parametro+2);
				if((num_copias<1)||(num_copias>100))
					num_copias=1;
			} else {
				num_copias=atoi(argv[n_parametro]);
				if((num_copias<1)||(num_copias>100))
					num_copias=1;
				n_parametro++;
			}
		break;
		default:
			printf("ERROR: unknown parameter %s. Exiting\n",parametro);
			exit(1);
		break;
	}
	
	return (n_parametro);
}

void procesa_parametros(int argc,char *argv[]) {

	gint parametro;
	
	ficherops=NULL;
	
	parametros=g_string_new("");
	if(argc<2) {
		ficherops=g_string_new("/dev/stdin");
		return;
	}
	
	parametro=1;
	while(parametro<argc)
		parametro=read_param(parametro,argv);

	if(ficherops==NULL) // if the filename hasn't been set, we use stdin
		ficherops=g_string_new("/dev/stdin");
}

void load_config() {

	FILE *fichero;
	GString *cadena;
	GtkWidget *printer;
	gchar impresora[33];

	printer=lookup_widget(mainwindow,"impresora");

	cadena=g_string_new(getenv("HOME"));
	g_string_append(cadena,"/.gtkpsproc");
	fichero=fopen(cadena->str,"r");
  
	if(fichero==NULL) {
		first_time=1; // is the first time, so we MUST put a configuration (avoid CANCEL)
		first_time_window=create_firsttime();
		gtk_widget_show(first_time_window);
		return;
	}

	first_time=0;
	fscanf(fichero,"%1c%1c%32s",&configuracion,&margen,impresora);
	gtk_entry_set_text(GTK_ENTRY(printer),impresora);
	fclose(fichero);
}

int checkexist(gchar *fichero) {
	
	struct stat estado;	
	int retorno;
	
	retorno=stat(fichero,&estado);
	if(retorno==0)
		return 0;
	else
		return 1;	
}

int
main (int argc, char *argv[])
{

	int retorno,retorno2;
	GtkWidget *ventana_error;
	
#ifdef ENABLE_NLS
	bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
	textdomain (GETTEXT_PACKAGE);
#endif

	gtk_set_locale ();
	gtk_init (&argc, &argv);

	add_pixmap_directory ("/usr/share/pixmaps/gtkpsproc/");

/* here we check that the PSUTILS are installed in the system */	
	
	retorno=checkexist("/usr/bin/pstops");
	retorno2=checkexist("/usr/bin/psnup");
	
	// if there's 
	if((retorno!=0)||(retorno2!=0)) {
		ventana_error = create_nopsutils();
		gtk_widget_show (ventana_error);
	} else {	
		evenpagesOK=about_window=first_time_window=config_window=NULL;
		mainwindow = create_mainwindow ();
		num_copias=1;
		procesa_parametros(argc,argv);
		gtk_spin_button_set_value(GTK_SPIN_BUTTON(lookup_widget(mainwindow,"copias")),num_copias);
		gtk_widget_show (mainwindow);
		load_config();		
	}

	gtk_main ();
	return 0;
}
